﻿#pragma once

namespace ChromaticButtonKeyboard
{
	public ref class Key sealed : public Windows::UI::Xaml::Controls::ContentControl
	{
    private:
        static Windows::UI::Xaml::DependencyProperty^ isPressedProperty;
        Platform::Collections::Vector<unsigned int>^ pointerList;

	public:
		Key();

        event Windows::Foundation::EventHandler<bool>^ IsPressedChanged;

        static property Windows::UI::Xaml::DependencyProperty^ IsPressedProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get();
        };

        property bool IsPressed
        {
            void set(bool);
            bool get();
        };

   	protected:
        virtual void OnPointerEntered(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args) override;
        virtual void OnPointerPressed(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args) override;
        virtual void OnPointerReleased(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args) override;
        virtual void OnPointerExited(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args) override;

    private:
        void AddToList(unsigned int id);
        void RemoveFromList(unsigned int id);
        void CheckList();
        static void OnIsPressedChanged(Windows::UI::Xaml::DependencyObject^ sender, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);
	};
}
