﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace OscillatorCompare;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

MainPage::MainPage()
{
	InitializeComponent();

    // Create an IXAudio2 object
    HRESULT hr = XAudio2Create(&pXAudio2);

    if (FAILED(hr))
        ref new COMException(hr, "XAudio2Create failure");

    // Create a mastering voice
    hr = pXAudio2->CreateMasteringVoice(&pMasteringVoice);

    if (FAILED(hr))
        ref new COMException(hr, "CreateMasteringVoice failure");

    // Create two oscillators
    pSawtoothOscillator1 = new SawtoothOscillator1(pXAudio2.Get());
    freq1Slider->Value = 69;    // ie, 440 Hz
    vol1Slider->Value = 25;
    
    pSawtoothOscillator2 = new SawtoothOscillator2(pXAudio2.Get());
    freq2Slider->Value = 69;    // ie, 440 Hz
    vol2Slider->Value = 25;
}

void MainPage::OnFreq1SliderValueChanged(Object^ sender, RangeBaseValueChangedEventArgs^ args)
{
    if (pSawtoothOscillator1 != nullptr)
    {
        int noteNum = (int)args->NewValue;
        double freq = 440 * pow(2, (noteNum - 69) / 12.0);
        pSawtoothOscillator1->SetFrequency((float)freq);
    }
}

void MainPage::OnVol1SliderValueChanged(Object^ sender, RangeBaseValueChangedEventArgs^ args)
{
    if (pSawtoothOscillator1 != nullptr)
    {
        pSawtoothOscillator1->SetAmplitude((float)(args->NewValue / 100));
    }
}

void MainPage::OnFreq2SliderValueChanged(Object^ sender, RangeBaseValueChangedEventArgs^ args)
{
    if (pSawtoothOscillator2 != nullptr)
    {
        int noteNum = (int)args->NewValue;
        double freq = 440 * pow(2, (noteNum - 69) / 12.0);
        pSawtoothOscillator2->SetFrequency((float)freq);
    }
}

void MainPage::OnVol2SliderValueChanged(Object^ sender, RangeBaseValueChangedEventArgs^ args)
{
    pSawtoothOscillator2->SetAmplitude((float)(args->NewValue / 100));
}
