﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "SawtoothOscillator1.h"
#include "SawtoothOscillator2.h"
#include "IndexToPitchConverter.h"

namespace OscillatorCompare
{
	public ref class MainPage sealed
	{
    private:
        Microsoft::WRL::ComPtr<IXAudio2> pXAudio2;
        IXAudio2MasteringVoice * pMasteringVoice;
        SawtoothOscillator1 * pSawtoothOscillator1;
        SawtoothOscillator2 * pSawtoothOscillator2;

	public:
		MainPage();

    private:
        void OnFreq1SliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnVol1SliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnFreq2SliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
        void OnVol2SliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
    };
}
