#pragma once

namespace OscillatorCompare
{
    class SawtoothOscillator2 : public IXAudio2VoiceCallback
    {
    private:
        static const int BUFFER_LENGTH = 1024;
        static const int WAVEFORM_LENGTH = 8192;

        IXAudio2SourceVoice * pSourceVoice;
        short * pWaveformBuffer;
        int index;
        int angle;
        int angleIncrement;

    public:
        SawtoothOscillator2(IXAudio2* pXAudio2);
        ~SawtoothOscillator2();
        void SetFrequency(float freq);
        void SetAmplitude(float amp);

        // Callbacks required for IXAudio2VoiceCallback
        void _stdcall OnVoiceProcessingPassStart(UINT32 bytesRequired);
        void _stdcall OnVoiceProcessingPassEnd(){}
        void _stdcall OnStreamEnd(){}
        void _stdcall OnBufferStart(void* pContext){};
        void _stdcall OnBufferEnd(void* pContext){};
        void _stdcall OnLoopEnd(void*){}
        void _stdcall OnVoiceError(void*, HRESULT){}

    private:
        void FillAndSubmit(int startIndex, int count);
    };
}

